POJ--3126--Prime Path

14 篇文章 0 订阅

题目描述:
The ministers of the cabinet were quite upset by the message from the Chief of Security stating that they would all have to change the four-digit room numbers on their offices.
— It is a matter of security to change such things every now and then, to keep the enemy in the dark.
— But look, I have chosen my number 1033 for good reasons. I am the Prime minister, you know!
— I know, so therefore your new number 8179 is also a prime. You will just have to paste four new digits over the four old ones on your office door.
— No, it’s not that simple. Suppose that I change the first digit to an 8, then the number will read 8033 which is not a prime!
— I see, being the prime minister you cannot stand having a non-prime number on your door even for a few seconds.
— Correct! So I must invent a scheme for going from 1033 to 8179 by a path of prime numbers where only one digit is changed from one prime to the next prime.

Now, the minister of finance, who had been eavesdropping, intervened.
— No unnecessary expenditure, please! I happen to know that the price of a digit is one pound.
— Hmm, in that case I need a computer program to minimize the cost. You don’t know some very cheap software gurus, do you?
— In fact, I do. You see, there is this programming contest going on… Help the prime minister to find the cheapest prime path between any two given four-digit primes! The first digit must be nonzero, of course. Here is a solution in the case above.
1033
1733
3733
3739
3779
8779
8179
The cost of this solution is 6 pounds. Note that the digit
输入描述:
One line with a positive number: the number of test cases (at most 100). Then for each test case, one line with two numbers separated by a blank. Both numbers are four-digit primes (without leading zeros).
输出描述:
One line for each case, either with a number stating the minimal cost or containing the word Impossible.
输入:
3
1033 8179
1373 8017
1033 1033
输出:
6
7
0
题意:
随机挑选两个四位的素数a,b。
游戏规则是:a可以通过改变某一位上的数字使其变成c,但只有当c也是四位的素数时才能进行这种改变。
例如:1033 -> 8179
1033
1733
3733
3739
3779
8779
8179
最少变换了6次。
题解
BFS
首先打出四位数的素数
然后把这个四位数拆成一个个的开始搜
代码:

#include<cstdio>
#include<cstring>
#include<algorithm>
#include<iostream>
#include<queue>
using namespace std;

const int maxn = 10000 + 5;
bool prime[maxn];


void init(){
	for(int i = 1000; i <= maxn; i ++) prime[i] = true;
	for(int i = 1000;i <= maxn; i ++){
		for(int j = 2;j * j <= i; j ++)
			if(i % j == 0){
				prime[i] = false;
				break;
			}
	}
}

int bfs(int first,int last){
    bool vis[maxn];
    int dis[maxn],v[5];
    memset(vis,false,sizeof(vis));
    memset(dis,0,sizeof(dis));
    vis[first] = true;
    int cnt = 0,tmp,num;
    queue<int> q;
    q.push(first);
    while(!q.empty()){
        int cnt = q.front();
        q.pop();
		v[0] = cnt / 1000;
		v[1] = cnt % 1000 / 100;
		v[2] = cnt % 100 / 10;
		v[3] = cnt % 10;
		for(int i = 0; i < 4; i ++){
            tmp = v[i];
            for(int j = 0; j < 10; j ++){
                if(j != tmp){
                    v[i] = j;
                    num = v[0] * 1000 + v[1] * 100 + v[2] * 10 + v[3];
                    if(!vis[num] && prime[num]){
                        dis[num] = dis[cnt] + 1;
                        vis[num] = true;
                        q.push(num);
                    }
                }
                if(num == last) return dis[num];
            }
            v[i] = tmp;
		}
		if(cnt == last) return dis[cnt];
    }
    return -1;
}

int main(){
    init();
    int t,a,b;
    scanf("%d",&t);
    while(t--){
        scanf("%d%d",&a,&b);
        int ans = bfs(a,b);
        printf("%d\n",ans);
    }
    return 0;
}
  • 0
    点赞
  • 0
    收藏
    觉得还不错? 一键收藏
  • 0
    评论

“相关推荐”对你有帮助么?

  • 非常没帮助
  • 没帮助
  • 一般
  • 有帮助
  • 非常有帮助
提交
评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值